BB55:       .equ 18h   ;номер порта для работы с микросхемой КР580ВВ55
BB55_2:     .equ 28h   ;номер порта для записи во вторую группу
PORTA:      .equ 0     ;порт А микросхемы КР580ВВ55
PORTB:      .equ 1     ;порт B микросхемы КР580ВВ55
PORTC:      .equ 2     ;порт С микросхемы КР580ВВ55
BB55_CTL:   .equ 3     ;регистр управления микросхемы КР580ВВ55
BB55_0:     .equ 38h   ;номер порта для работы с микросхемой общего
интерфейса

entry:
      .org 0000h
      jp    entry         ;переход на начало программы
      .org 0100h
entry:
      ld    a, 9Bh
      out   (BB55 + BB55_CTL)   ;конфигурирование ВВ55 на ввод
      ld    a, 0h
      out   (BB55_2 + BB55_CTL) ;конфигурирование ВВ55 на вывод
      out   (BB55_0 + BB55_CTL) ;конфигурирование контроллера общего
                                ;интерфейса на вывод
copy1:
      ld    bc, 2000h    ;начальный адрес локальной памяти
copybyte:
      in    l, (BB55+PORTA)
      in    h, (BB55+PORTB)
      in    a, (BB55+PORTC)
      out   (BB55_2+PORTA), l ;передача байтов в защёлки для второй группы
      out   (BB55_0+PORTA), l ;передача байтов в защёлки для общего
                              ;интерфейса
      out   (BB55_2+PORTB), h
      out   (BB55_0+PORTB), h
      out   (BB55_2+PORTC), a
      out   (BB55_0+PORTC), a
      ld    a, b
      cp    h           ;если принятый адрес не совпадает с указателем
      jp    nz, getnext ;переключаемся на другой процессор
      ld    a, c
      cp    l
      jp    nz, getnext
      ld    a, d        ;приём байта данных, если адреса совпали
      ld    (bc), a     ;записываем байт в локальную память
      inc   bc
getnext:
      halt              ;ожидаем разрешающего сигнала от второго
                        ;процессора группы
      ld    a, с
      cp    4Fh         ;достигли конца локальной памяти?
      jr nz copybyte    ;если, продолжаем
      jp    copy1
      .end
