BB55:       .equ 18h   ;номер порта для работы с микросхемой КР580ВВ55
BB55_2:     .equ 28h   ;номер порта для записи в группу
PORTA:      .equ 0     ;порт А микросхемы КР580ВВ55
PORTB:      .equ 1     ;порт B микросхемы КР580ВВ55
PORTC:      .equ 2     ;порт С микросхемы КР580ВВ55
BB55_CTL:   .equ 3     ;регистр управления микросхемы КР580ВВ55

entry:
      .org 0000h
      jp entry         ;переход на начало программы
      .org 0100h
entry:
      ld   A, 9Bh
      out  (BB55 + BB55_CTL)   ;конфигурирование ВВ55 на ввод
      ld   A, 0h
      out  (BB55_2 + BB55_CTL) ;конфигурирование ВВ55 на вывод
copy1:
      ld   bc, 2000h           ;начальный адрес локальной памяти
copybyte:
      in   l, (BB55+PORTA)
      in   h, (BB55+PORTB)
      in   a, (BB55+PORTC)
      out  (BB55_2+PORTA), l   ;передача байтов в защёлки для второй группы
      out  (BB55_2+PORTB), h
      out  (BB55_2+PORTC), a
      ld   d, a         ;сохраняем принятое значение
      ld   a, b
      cp   H            ;если принятый адрес не совпадает с указателем
      jp   nz, getnext  ;переключаемся на другой процессор
      ld   a, c
      cp   l
      jp   nz, getnext
      ld   a, d       ;приём байта данных, если адреса совпали
      ld   (bc), a    ;записываем байт в локальную память
      inc  bc
getnext:
      halt            ;ожидаем разрешающего сигнала от второго процессора группы
      ld  a, с
      cp  4Fh         ;достигли конца локальной памяти?
      jr nz copybyte  ;если, продолжаем
      jp  copy1
      .end
